using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Data.SqlClient;
using System.Drawing;
using System.IO;
using System.Text;
using RKLib.ExportData;

public partial class TransactionReport : System.Web.UI.Page
{
    Allfunctions exporttoexcel = new Allfunctions();
    string date = DateTime.Now.ToString();
    protected void Page_Load(object sender, EventArgs e)
    {
        try
        {
            if (Session["LOGINID"] == null && Session["USERNAME"] == null)
            {
                Response.Redirect("../login.aspx");
            }
            if (!IsPostBack)
            {
                lbluserid.Visible = false;
                ddl_partner_id.Visible = false;
            }
            btndownload.Visible = false;
        }
        catch (Exception ex)
        {
            throw (ex);
        }  
    }
    private void BindDataAccServices()
    {
        string  todaysdate = DateTime.Now.ToShortDateString();
        try
        {
            SqlParameter[] param = new SqlParameter[]
            {
                new SqlParameter("@loginid",ddl_partner_id.SelectedValue.ToString()),
                new SqlParameter("@ServiceType","ALL Services"),
                new SqlParameter("@Fromdate",txtFrmDate.Text.Trim()),
                new SqlParameter("@Todate",txtToDate.Text.Trim())
            };
            DataSet ds = SqlHelper.GetDataSet(SqlHelper.mainConnectionString, CommandType.StoredProcedure, "USP_ALLTRANSACTION_REPORT", param);           
            if (ds.Tables[0].Rows.Count != 0)
            {
                GvTransactionReport.DataSource = ds;
                GvTransactionReport.DataBind();
                lblerror.Visible = false;
                btndownload.Visible =true;
                GvTransactionReport.Visible = true;
            }
            else
            {
                lblerror.Visible = true;
                lblerror.Text = "No transaction available";
                lblerror.ForeColor = Color.Red;
                GvTransactionReport.Visible = false;
            }
        }
        catch (Exception ev)
        {
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "OhCrap", String.Format("alert('There is some technical problem. Please try again');"), true);
        }
    }
    private void gettransaction_details()
    {
        try
        {
            SqlParameter[] param = new SqlParameter[]
            {
                new SqlParameter("@loginid",Session["LOGINID"].ToString()),
            };
            DataSet ds = SqlHelper.GetDataSet(SqlHelper.mainConnectionString, CommandType.StoredProcedure, "USP_ALLTRANSACTION", param);
            if (ds.Tables[0].Rows.Count != 0)
            {
                GvTransactionReport.DataSource = ds;
                GvTransactionReport.DataBind();
                GvTransactionReport.Visible = true;
            }
        }
        catch (Exception ev)
        {
            Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "OhCrap", String.Format("alert('There is some technical problem. Please try again');"), true);
        }
    }
    protected void BtnSubmit_Click(object sender, EventArgs e)
    {
        if (Convert.ToDateTime(txtFrmDate.Text).Date > Convert.ToDateTime(date))
        {
            lblerror.Text = "Date must be less then current date";
            lblerror.ForeColor = Color.Red;
        }
        else
        {
            BindDataAccServices();
        }
    }
    protected void btndownload_Click(object sender, EventArgs e)
    {        
        try
        {
            SqlParameter[] param = new SqlParameter[]
            {
                new SqlParameter("@loginid",ddl_partner_id.SelectedValue.ToString()),
                new SqlParameter("@ServiceType","ALL Services"),
                new SqlParameter("@Fromdate",txtFrmDate.Text.Trim()),
                new SqlParameter("@Todate",txtToDate.Text.Trim())
            };
            DataSet ds = SqlHelper.GetDataSet(SqlHelper.mainConnectionString, CommandType.StoredProcedure, "USP_ALLTRANSACTION_REPORT", param);           
            if (ds.Tables[0].Rows.Count != 0)
            {
                lblerror.Visible = false;
                DataTable dtEmployee = ds.Tables["Table"].Copy();
                int[] iColumns = { 1,2,3,4,5,6,7,8,};
                RKLib.ExportData.Export objExport = new
                RKLib.ExportData.Export("Web");
                objExport.ExportDetails(dtEmployee,
                iColumns, Export.ExportFormat.CSV,
                "C:\\Transactiondetails.csv");
            }
            else
            {
                lblerror.Visible = true;
                lblerror.Text = "No transaction available";
                lblerror.ForeColor = Color.Red;
            }
        }
        catch(Exception ev)
        {
            //Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "OhCrap", String.Format("alert('There is some technical problem. Please try again');"), true);
            throw (ev);
        }
    }
    public override void VerifyRenderingInServerForm(Control control)
    {

    }
    protected void GvTransactionReport_PageIndexChanging(object sender, GridViewPageEventArgs e)
    {
        try
        {
            GvTransactionReport.PageIndex = e.NewPageIndex;
            BindDataAccServices();
        }
        catch (Exception ex)
        {
            throw (ex);
        }  
    }
    protected void DDL_UserType_SelectedIndexChanged(object sender, EventArgs e)
    {
        lbluserid.Visible = true;
        ddl_partner_id.Visible = true;
        try
        {
            if (DDL_UserType.SelectedItem.Text.Equals("Distributor"))
            {
                SqlParameter[] GetAgent = new SqlParameter[]
                {
                    new SqlParameter("@Loginid",Session["LOGINID"].ToString()),
                    new SqlParameter("@Usertype","Distributor"), 
                };
                DataSet ds = SqlHelper.GetDataSet(SqlHelper.mainConnectionString, CommandType.StoredProcedure, "udp_GetMDS_DS_AG_OFWL", GetAgent);
                if (ds.Tables[0].Rows.Count > 0)
                {
                    ddl_partner_id.DataSource = ds;
                    ddl_partner_id.DataTextField = "USERNAME";
                    ddl_partner_id.DataValueField = "LOGINID";
                    ddl_partner_id.DataBind();
                    ddl_partner_id.Visible = true;
                }
            }
            else
            {
                SqlParameter[] GetAgent = new SqlParameter[]
                {
                    new SqlParameter("@Loginid",Session["LOGINID"].ToString()),
                    new SqlParameter("@Usertype","Agent"),
                };
                DataSet ds = SqlHelper.GetDataSet(SqlHelper.mainConnectionString, CommandType.StoredProcedure, "udp_GetMDS_DS_AG_OFWL", GetAgent);
                if (ds.Tables[0].Rows.Count > 0)
                {
                    ddl_partner_id.DataSource = ds;
                    ddl_partner_id.DataTextField = "USERNAME";
                    ddl_partner_id.DataValueField = "LOGINID";
                    ddl_partner_id.DataBind();
                    ddl_partner_id.Visible = true;
                }
            }
        }
        catch(Exception ex)
        {
            //Page.ClientScript.RegisterClientScriptBlock(this.GetType(), "OhCrap", String.Format("alert('There is some technical problem. Please try again');"), true);
            throw (ex);
        }
    }
}
